## fifechan 0.1.3

=== CMakeLists.txt ===
#------------------------------------------------------------------------------
#                                 FifeChan / FifeGUI                                         
#------------------------------------------------------------------------------

CMAKE_MINIMUM_REQUIRED(VERSION 2.6.0)

PROJECT(fifechan)

#------------------------------------------------------------------------------
#                                 Version                                          
#------------------------------------------------------------------------------

SET(MAJOR_VERSION 0)
SET(MINOR_VERSION 1)
SET(PATCH_VERSION 3)
SET(FIFECHAN_VERSION ${MAJOR_VERSION}.${MINOR_VERSION}.${PATCH_VERSION})

SET(LIB_SUFFIX "" CACHE STRING "Suffix to append to the system lib folder")

#------------------------------------------------------------------------------
#                                 Options                                          
#------------------------------------------------------------------------------

OPTION(BUILD_FIFECHAN_SHARED            "Build the Fifechan core library as a shared library"                ON)

OPTION(ENABLE_ALLEGRO                   "Enable the Fifechan Allegro extension"                              ON)
OPTION(BUILD_FIFECHAN_ALLEGRO_SHARED    "Build the Fifechan Allegro extension library as a shared library"   ON)

OPTION(ENABLE_IRRLICHT                  "Enable the Fifechan Irrlicht extension"                             ON)
OPTION(BUILD_FIFECHAN_IRRLICHT_SHARED   "Build the Fifechan Irrlicht extension library as a shared library"  ON)

OPTION(ENABLE_OPENGL                    "Enable the Fifechan OpenGL extension"                               ON)
OPTION(ENABLE_OPENGL_CONTRIB            "Enable the Fifechan OpenGL contrib extension (freetype, oglft)"     OFF)
OPTION(BUILD_FIFECHAN_OPENGL_SHARED     "Build the Fifechan OpenGL extension library as a shared library"    ON)

OPTION(ENABLE_SDL                       "Enable the Fifechan SDL extension"                                  ON)
OPTION(ENABLE_SDL_CONTRIB               "Enable the Fifechan SDL contrib extension (SDL2_ttf)"               OFF)
OPTION(BUILD_FIFECHAN_SDL_SHARED        "Build the Fifechan SDL extension library as a shared library"       ON)

#------------------------------------------------------------------------------
#                                 Display Status                                         
#------------------------------------------------------------------------------

message("")
message("== Building FIFECHAN version ${FIFECHAN_VERSION} using build type '${CMAKE_BUILD_TYPE}'.")
message(STATUS "    Source directory is '${PROJECT_SOURCE_DIR}'.")
message(STATUS "    Build  directory is '${PROJECT_BINARY_DIR}'.")
message(STATUS "    Installation path is '${CMAKE_INSTALL_PREFIX}' (set -DCMAKE_INSTALL_PREFIX=<path> to change).")
message("")

#------------------------------------------------------------------------------
#                           Find Dependencies - Windows                                        
#------------------------------------------------------------------------------

# Tell CMake where to search for binaries (dlls), includes and libs on Windows
if(WIN32)
  set(CMAKE_PREFIX_PATH ${CMAKE_PREFIX_PATH}
    "${PROJECT_SOURCE_DIR}/../fifechan-dependencies/includes/bin"
    "${PROJECT_SOURCE_DIR}/../fifechan-dependencies/includes/include"
    "${PROJECT_SOURCE_DIR}/../fifechan-dependencies/includes/include/SDL2"
    "${PROJECT_SOURCE_DIR}/../fifechan-dependencies/includes/lib/x86"
    "${PROJECT_SOURCE_DIR}/../fifechan-dependencies/includes/lib"    
  )
endif(WIN32)

#------------------------------------------------------------------------------
#                                 Configure                                          
#------------------------------------------------------------------------------

# Path to local modules
SET(CMAKE_MODULE_PATH ${CMAKE_SOURCE_DIR}/CMake/Modules)

# Do not allow an in-source-tree build, request an out-of-source-tree build.
if (CMAKE_SOURCE_DIR STREQUAL CMAKE_BINARY_DIR)
  message(FATAL_ERROR "#Please build outside of the source tree!\n                        
                       Make a separate folder for building and run CMake there:\n
                       mkdir _build; cd _build; cmake ..\n
                       Before that, cleanup:\nrm -rf CMakeCache.txt CMakeFiles")
endif()

# Disable in-source builds and modifications to the source tree.
set(CMAKE_DISABLE_SOURCE_CHANGES ON)
set(CMAKE_DISABLE_IN_SOURCE_BUILD ON)

#------------------------------------------------------------------------------
#                                 Source Files                                             
#------------------------------------------------------------------------------

INCLUDE_DIRECTORIES("${PROJECT_SOURCE_DIR}/include")

# The Fifechan core library 
FILE(GLOB FIFECHAN_HEADER include/fifechan.hpp)
FILE(GLOB FIFECHAN_HEADERS
  include/fifechan/actionevent.hpp		
  include/fifechan/actionlistener.hpp		
  include/fifechan/cliprectangle.hpp	
  include/fifechan/color.hpp		
  include/fifechan/containerevent.hpp		
  include/fifechan/containerlistener.hpp		
  include/fifechan/deathlistener.hpp	
  include/fifechan/defaultfont.hpp		
  include/fifechan/event.hpp		
  include/fifechan/exception.hpp
  include/fifechan/fixedsizeconstraint.hpp  
  include/fifechan/focushandler.hpp	
  include/fifechan/focuslistener.hpp	
  include/fifechan/font.hpp		
  include/fifechan/genericinput.hpp	
  include/fifechan/glut.hpp		
  include/fifechan/graphics.hpp		
  include/fifechan/gui.hpp			
  include/fifechan/image.hpp		
  include/fifechan/imagefont.hpp		
  include/fifechan/imageloader.hpp		
  include/fifechan/input.hpp		
  include/fifechan/inputevent.hpp		
  include/fifechan/key.hpp			
  include/fifechan/keyevent.hpp		
  include/fifechan/keyinput.hpp		
  include/fifechan/keylistener.hpp		
  include/fifechan/listmodel.hpp		
  include/fifechan/mouseevent.hpp		
  include/fifechan/mouseinput.hpp		
  include/fifechan/mouselistener.hpp	
  include/fifechan/platform.hpp		
  include/fifechan/rectangle.hpp		
  include/fifechan/selectionevent.hpp	
  include/fifechan/selectionlistener.hpp	
  include/fifechan/size.hpp
  include/fifechan/sizeconstraint.hpp
  include/fifechan/text.hpp
  include/fifechan/utf8stringeditor.hpp
  include/fifechan/visibilityeventhandler.hpp
  include/fifechan/widget.hpp		
  include/fifechan/widgetlistener.hpp
  include/fifechan/opengl.hpp
)
FILE(GLOB FIFECHAN_WIDGET_HEADERS include/fifechan/widgets/*.hpp)
FILE(GLOB FIFECHAN_SRC src/*.cpp)
FILE(GLOB FIFECHAN_WIDGET_SRC src/widgets/*.cpp)

# Grouping of the source for nicer display in IDEs such as Visual Studio
SOURCE_GROUP(src                          FILES ${FIFECHAN_HEADER})
SOURCE_GROUP(src/fifechan                 FILES ${FIFECHAN_HEADERS} ${FIFECHAN_SRC})
SOURCE_GROUP(src/fifechan/widgets         FILES ${FIFECHAN_WIDGET_HEADERS} ${FIFECHAN_WIDGET_SRC})

#------------------------------------------------------------------------------
#                 Fifechan core library as a shared library                                        
#------------------------------------------------------------------------------

IF(BUILD_FIFECHAN_SHARED)
  SET(FIFECHAN_LIBRARY_TYPE SHARED)
ELSE(BUILD_FIFECHAN_SHARED)
  SET(FIFECHAN_LIBRARY_TYPE STATIC)
ENDIF(BUILD_FIFECHAN_SHARED)

ADD_LIBRARY(${PROJECT_NAME} ${FIFECHAN_LIBRARY_TYPE} 
	${FIFECHAN_HEADER} 
	${FIFECHAN_HEADERS} 
	${FIFECHAN_WIDGET_HEADERS} 
	${FIFECHAN_SRC} 
	${FIFECHAN_WIDGET_SRC}
)

ADD_CUSTOM_TARGET(lib DEPENDS ${PROJECT_NAME}) # Create symlink

SET_TARGET_PROPERTIES(${PROJECT_NAME} PROPERTIES
  VERSION                 ${FIFECHAN_VERSION}
  SOVERSION               ${FIFECHAN_VERSION}
  CLEAN_DIRECT_OUTPUT     1                             # Allow creating static and shared libraries without conflict
  OUTPUT_NAME             ${PROJECT_NAME}               # Avoid conflicts between library and binary target names 
  COMPILE_DEFINITIONS     "FIFECHAN_BUILD"
)

INSTALL(TARGETS ${PROJECT_NAME} DESTINATION lib${LIB_SUFFIX} PERMISSIONS
  OWNER_READ OWNER_WRITE OWNER_EXECUTE
  GROUP_READ GROUP_EXECUTE
  WORLD_READ WORLD_EXECUTE
)

INSTALL(FILES ${FIFECHAN_HEADER}                  DESTINATION include/)
INSTALL(FILES ${FIFECHAN_HEADERS}                 DESTINATION include/fifechan/)
INSTALL(FILES ${FIFECHAN_WIDGET_HEADERS}          DESTINATION include/fifechan/widgets/)

#REMOVE_DEFINITIONS("-DFIFECHAN_BUILD")
#ADD_DEFINITIONS("-DFIFECHAN_EXTENSION_BUILD")

#------------------------------------------------------------------------------
#                   The Fifechan Allegro extension library                                         
#------------------------------------------------------------------------------

FIND_PACKAGE(Allegro)

IF(ENABLE_ALLEGRO AND ALLEGRO_FOUND)  

  INCLUDE_DIRECTORIES(${ALLEGRO_INCLUDE_DIR})

  # The Fifechan Allegro extension source
  FILE(GLOB FIFECHAN_ALLEGRO_HEADER include/fifechan/allegro.hpp)
  FILE(GLOB FIFECHAN_ALLEGRO_HEADERS include/fifechan/allegro/*.hpp)
  FILE(GLOB FIFECHAN_ALLEGRO_CONTRIB_HEADERS include/fifechan/contrib/allegro/*.hpp)
  FILE(GLOB FIFECHAN_ALLEGRO_SRC src/allegro/*.cpp)

  # Grouping of the source for nicer display in IDEs such as Visual Studio
  SOURCE_GROUP(src/fifechan FILES ${FIFECHAN_ALLEGRO_HEADER})
  SOURCE_GROUP(src/fifechan/allegro FILES ${FIFECHAN_ALLEGRO_HEADERS} ${FIFECHAN_ALLEGRO_SRC})
  SOURCE_GROUP(src/fifechan/contrib/allegro FILES ${FIFECHAN_ALLEGRO_CONTRIB_HEADERS})

  IF(BUILD_FIFECHAN_ALLEGRO_SHARED)
    SET(FIFECHAN_ALLEGRO_LIBRARY_TYPE SHARED)
  ELSE(BUILD_FIFECHAN_ALLEGRO_SHARED)
     SET(FIFECHAN_ALLEGRO_LIBRARY_TYPE STATIC)
  ENDIF(BUILD_FIFECHAN_ALLEGRO_SHARED)

  ADD_LIBRARY(${PROJECT_NAME}_allegro ${FIFECHAN_ALLEGRO_LIBRARY_TYPE} 
  	${FIFECHAN_ALLEGRO_HEADER}
  	${FIFECHAN_ALLEGRO_HEADERS}
  	${FIFECHAN_ALLEGRO_CONTRIB_HEADERS}
  	${FIFECHAN_ALLEGRO_SRC}
  )

  TARGET_LINK_LIBRARIES(${PROJECT_NAME}_allegro ${ALLEG_LIBRARY} ${PROJECT_NAME})
  
  ADD_CUSTOM_TARGET(allegrolib DEPENDS ${PROJECT_NAME}_allegro) # Create symlink
  
  SET_TARGET_PROPERTIES(${PROJECT_NAME}_allegro PROPERTIES
    VERSION                   ${FIFECHAN_VERSION}
    SOVERSION                 ${FIFECHAN_VERSION}
    CLEAN_DIRECT_OUTPUT       1                               # Allow creating static and shared libraries without conflict
    OUTPUT_NAME               ${PROJECT_NAME}_allegro         # Avoid conflicts between library and binary target names 
    COMPILE_DEFINITIONS       "FIFECHAN_EXTENSION_BUILD"
  )

  INSTALL(TARGETS ${PROJECT_NAME}_allegro DESTINATION lib${LIB_SUFFIX} PERMISSIONS
    OWNER_READ OWNER_WRITE OWNER_EXECUTE
    GROUP_READ GROUP_EXECUTE
    WORLD_READ WORLD_EXECUTE
  )

  INSTALL(FILES ${FIFECHAN_ALLEGRO_HEADER}            DESTINATION include/fifechan/)
  INSTALL(FILES ${FIFECHAN_ALLEGRO_HEADERS}           DESTINATION include/fifechan/allegro/)
  INSTALL(FILES ${FIFECHAN_ALLEGRO_CONTRIB_HEADERS}   DESTINATION include/fifechan/contrib/allegro/)  

ENDIF(ENABLE_ALLEGRO AND ALLEGRO_FOUND)

#------------------------------------------------------------------------------
#                   Fifechan Irrlicht extension library                                         
#------------------------------------------------------------------------------

FIND_PACKAGE(Irrlicht)
IF(ENABLE_IRRLICHT AND IRRLICHT_FOUND)

  INCLUDE_DIRECTORIES(${IRRLICHT_INCLUDE_DIR})

  # The Fifechan Irrlicht extension source
  FILE(GLOB FIFECHAN_IRRLICHT_HEADER include/fifechan/irrlicht.hpp)
  FILE(GLOB FIFECHAN_IRRLICHT_HEADERS include/fifechan/irrlicht/*.hpp)
  FILE(GLOB FIFECHAN_IRRLICHT_SRC src/irrlicht/*.cpp)

  # Grouping of the source for nicer display in IDEs such as Visual Studio
  SOURCE_GROUP(src/fifechan FILES ${FIFECHAN_IRRLICHT_HEADER})
  SOURCE_GROUP(src/fifechan/irrlicht FILES ${FIFECHAN_IRRLICHT_HEADERS} ${FIFECHAN_IRRLICHT_SRC})

=== debian/changelog ===
fifechan (0.1.3-3) unstable; urgency=medium

  * Add segfault-quit-game.patch and fix a segmentation fault when exiting
    unknown-horizons. Thanks to Petter Reinholdtsen for the report.
    (Closes: #852247)

 -- Markus Koschany <apo@debian.org>  Mon, 23 Jan 2017 19:36:17 +0100

fifechan (0.1.3-2) unstable; urgency=medium

  * Upload to unstable.

 -- Markus Koschany <apo@debian.org>  Thu, 19 Jan 2017 23:23:07 +0100

fifechan (0.1.3-1) experimental; urgency=medium

  * New upstream version 0.1.3.
  * Add get-orig-source target.
  * Rename binary package to libfifechan0.1.3 because of the SONAME change.

 -- Markus Koschany <apo@debian.org>  Mon, 07 Nov 2016 18:54:27 +0100

fifechan (0.1.2+git160920-1) unstable; urgency=medium

  * Initial release. (Closes: #838489)

 -- Markus Koschany <apo@debian.org>  Wed, 21 Sep 2016 21:25:06 +0200

=== debian/control ===
Source: fifechan
Section: libs
Priority: optional
Maintainer: Debian Games Team <pkg-games-devel@lists.alioth.debian.org>
Uploaders:
 Markus Koschany <apo@debian.org>
Build-Depends:
 cmake,
 debhelper (>= 10),
 liballegro4-dev,
 libgl1-mesa-dev,
 libglu1-mesa-dev,
 libsdl2-dev,
 libsdl2-image-dev,
 libsdl2-ttf-dev
Standards-Version: 3.9.8
Homepage: http://fifengine.net/
Vcs-Git: https://anonscm.debian.org/git/pkg-games/fifechan.git
Vcs-Browser: https://anonscm.debian.org/cgit/pkg-games/fifechan.git

Package: libfifechan0.1.3
Architecture: any
Multi-Arch: same
Depends:
 ${misc:Depends},
 ${shlibs:Depends}
Description: lightweight cross platform GUI library written in C++
 Fifechan is a lightweight cross platform GUI library written in C++
 specifically designed for games. It has a small yet powerful built in set of
 extendable GUI Widgets allowing users to create virtually unlimited types of
 widgets.
 .
 This package contains the runtime libraries for Fifechan.

Package: libfifechan-dev
Architecture: any
Section: libdevel
Multi-Arch: same
Depends:
 libfifechan0.1.3 (= ${binary:Version}),
 ${misc:Depends}
Description: development files for the GUI library Fifechan
 Fifechan is a lightweight cross platform GUI library written in C++
 specifically designed for games. It has a small yet powerful built in set of
 extendable GUI Widgets allowing users to create virtually unlimited types of
 widgets.
 .
 Fifechan supports rendering in SDL, OpenGL, or Allegro out of the box or it
 can be adapted to use any rendering engine the user requires. Events are
 pushed to Fifechan which allows users to use any input library they wish or
 they could use the built in input handling through either SDL input or Allegro
 input.
 .
 The primary goal for Fifechan is to keep it extendable, lightweight and still
 be powerful enough to use in all types of games out of the box.
 .
 This package contains development files for Fifechan.

=== debian/rules ===
#!/usr/bin/make -f
#export DH_VERBOSE=1

%:
	dh $@

override_dh_auto_configure:
	dh_auto_configure -- \
		-DLIB_SUFFIX=/$(DEB_HOST_MULTIARCH)

override_dh_install:
	dh_install --fail-missing

get-orig-source:
	uscan --download-current-version --force-download

## fifechan 0.1.4

=== CMakeLists.txt ===
--- 
+++ 
@@ -12,7 +12,7 @@
 
 SET(MAJOR_VERSION 0)
 SET(MINOR_VERSION 1)
-SET(PATCH_VERSION 3)
+SET(PATCH_VERSION 4)
 SET(FIFECHAN_VERSION ${MAJOR_VERSION}.${MINOR_VERSION}.${PATCH_VERSION})
 
 SET(LIB_SUFFIX "" CACHE STRING "Suffix to append to the system lib folder")
@@ -100,8 +100,7 @@
   include/fifechan/deathlistener.hpp	
   include/fifechan/defaultfont.hpp		
   include/fifechan/event.hpp		
-  include/fifechan/exception.hpp
-  include/fifechan/fixedsizeconstraint.hpp  
+  include/fifechan/exception.hpp 
   include/fifechan/focushandler.hpp	
   include/fifechan/focuslistener.hpp	
   include/fifechan/font.hpp		
@@ -126,8 +125,6 @@
   include/fifechan/rectangle.hpp		
   include/fifechan/selectionevent.hpp	
   include/fifechan/selectionlistener.hpp	
-  include/fifechan/size.hpp
-  include/fifechan/sizeconstraint.hpp
   include/fifechan/text.hpp
   include/fifechan/utf8stringeditor.hpp
   include/fifechan/visibilityeventhandler.hpp
@@ -261,3 +258,6 @@
   SOURCE_GROUP(src/fifechan FILES ${FIFECHAN_IRRLICHT_HEADER})
   SOURCE_GROUP(src/fifechan/irrlicht FILES ${FIFECHAN_IRRLICHT_HEADERS} ${FIFECHAN_IRRLICHT_SRC})
 
+  IF(BUILD_FIFECHAN_IRRLICHT_SHARED)
+    SET(FIFECHAN_IRRLICHT_LIBRARY_TYPE SHARED)
+  ELSE(BUILD_FIFECHAN_IRRLICHT_SHARED)

=== dependencies/CMakeLists.txt ===
#------------------------------------------------------------------------------
#                       FifeChan / FifeGUI Dependencies                                               
#------------------------------------------------------------------------------

CMAKE_MINIMUM_REQUIRED(VERSION 3.5)

PROJECT(fifechan-dependencies)

set(CMAKE_INSTALL_PREFIX    ${CMAKE_SOURCE_DIR}/../../${PROJECT_NAME}/includes)
set(CMAKE_MODULE_PATH       ${CMAKE_SOURCE_DIR}/../cmake)
set(CMAKE_VERBOSE_MAKEFILE  ON)

if (CMAKE_INSTALL_PREFIX_INITIALIZED_TO_DEFAULT)
    set (CMAKE_INSTALL_PREFIX "${CMAKE_BINARY_DIR}" CACHE PATH "default install path" FORCE )
endif()

message(STATUS "\nWelcome!\n== Build System for ${PROJECT_NAME}")

# create a "Release" build by default
if(NOT CMAKE_BUILD_TYPE)
  set(CMAKE_BUILD_TYPE "Release" CACHE STRING
    "Select build type. Options are: 'Debug', 'Release', 'RelWithDebInfo' and 'MinSizeRel'."
    FORCE
  )  
  message(STATUS "Set CMAKE_BUILD_TYPE to default '${CMAKE_BUILD_TYPE}'.")
endif(NOT CMAKE_BUILD_TYPE)

# set a fallback download folder for dependencies ("dependencies/../../${PROJECT_NAME}/downloads")
if(NOT DEPENDENCY_DOWNLOAD_DIR)
    set(DEPENDENCY_DOWNLOAD_DIR ${CMAKE_CURRENT_SOURCE_DIR}/../../${PROJECT_NAME}/downloads)
    message("   DEPENDENCY_DOWNLOAD_DIR not set. Using default.")
endif(NOT DEPENDENCY_DOWNLOAD_DIR)

# set a fallback installation folder for dependencies ("dependencies/../../${PROJECT_NAME}/includes")
if(NOT DEPENDENCY_INSTALL_DIR)
    set(DEPENDENCY_INSTALL_DIR ${CMAKE_CURRENT_SOURCE_DIR}/../../${PROJECT_NAME}/includes)
    message("   DEPENDENCY_INSTALL_DIR not set. Using default.")    
endif(NOT DEPENDENCY_INSTALL_DIR)

# set a fallback folder for the extracted dependencies ("dependencies/../../${PROJECT_NAME}/extracted")
if(NOT DEPENDENCY_EXTRACT_DIR)
    set(DEPENDENCY_EXTRACT_DIR ${CMAKE_CURRENT_SOURCE_DIR}/../../${PROJECT_NAME}/extracted)
    message("   DEPENDENCY_EXTRACT_DIR not set. Using default.")    
endif(NOT DEPENDENCY_EXTRACT_DIR)

#------------------------------------------------------------------------------
#                                 Display Status                                         
#------------------------------------------------------------------------------

message("")
message("== Config Overview")
message("")
message("   CMAKE_BUILD_TYPE           |  ${CMAKE_BUILD_TYPE}")
message("   CMAKE_BINARY_DIR           |  ${CMAKE_BINARY_DIR}")
message("   CMAKE_INSTALL_PREFIX       |  ${CMAKE_INSTALL_PREFIX}")
message("   DEPENDENCY_INSTALL_DIR     |  ${DEPENDENCY_INSTALL_DIR}") 
message("   DEPENDENCY_DOWNLOAD_DIR    |  ${DEPENDENCY_DOWNLOAD_DIR}") 
message("   DEPENDENCY_EXTRACT_DIR     |  ${DEPENDENCY_EXTRACT_DIR}") 
message("")

#------------------------------------------------------------------------------
#                                Options                                                   
#------------------------------------------------------------------------------

OPTION(FIFECHAN_DEPENDENCY_SDL2        "Download and build dependency: SDL2"       ON)
OPTION(FIFECHAN_DEPENDENCY_SDL2_IMAGE  "Download and build dependency: SDL2_IMAGE" ON)
OPTION(FIFECHAN_DEPENDENCY_SDL2_TTF    "Download and build dependency: SDL2_TTF"   ON)
OPTION(FIFECHAN_DEPENDENCY_ALLEGRO     "Download and build dependency: ALLEGRO"    OFF)
OPTION(FIFECHAN_DEPENDENCY_IRRLICHT    "Download and build dependency: IRRLICHT"   OFF)
OPTION(FIFECHAN_DEPENDENCY_OGLFT       "Download and build dependency: OGLFT"      OFF)

#------------------------------------------------------------------------------
#                   Check Options + Include external build scripts                                             
#------------------------------------------------------------------------------

IF(FIFECHAN_DEPENDENCY_SDL2)
    INCLUDE(get-sdl2)
ENDIF(FIFECHAN_DEPENDENCY_SDL2)

IF(FIFECHAN_DEPENDENCY_SDL2_IMAGE)
    INCLUDE(get-sdl2_image)
ENDIF(FIFECHAN_DEPENDENCY_SDL2_IMAGE)

IF(FIFECHAN_DEPENDENCY_SDL2_TTF)
    INCLUDE(get-sdl2_ttf)
ENDIF(FIFECHAN_DEPENDENCY_SDL2_TTF)

IF(FIFECHAN_DEPENDENCY_ALLEGRO)
    INCLUDE(get-allegro)
ENDIF(FIFECHAN_DEPENDENCY_ALLEGRO)

IF(FIFECHAN_DEPENDENCY_IRRLICHT)
    INCLUDE(get-irrlicht)
ENDIF(FIFECHAN_DEPENDENCY_IRRLICHT)

IF(FIFECHAN_DEPENDENCY_OGLFT)
    INCLUDE(get-oglft)
ENDIF(FIFECHAN_DEPENDENCY_OGLFT)

=== debian/changelog ===
fifechan (0.1.4-2) unstable; urgency=medium

  * Upload to unstable.
  * Declare compliance with Debian Policy 4.0.0.
  * Use https for Format field.

 -- Markus Koschany <apo@debian.org>  Thu, 06 Jul 2017 23:25:35 +0200

fifechan (0.1.4-1) experimental; urgency=medium

  * New upstream version 0.1.4.
  * Drop segfault-quit-game.patch. Fixed upstream.
  * Rename the binary package because of the SONAME bump.
  * export DEB_BUILD_MAINT_OPTIONS = hardening=+all.

 -- Markus Koschany <apo@debian.org>  Mon, 19 Jun 2017 21:11:46 +0200

=== debian/control ===
--- 
+++ 
@@ -13,12 +13,12 @@
  libsdl2-dev,
  libsdl2-image-dev,
  libsdl2-ttf-dev
-Standards-Version: 3.9.8
+Standards-Version: 4.0.0
 Homepage: http://fifengine.net/
 Vcs-Git: https://anonscm.debian.org/git/pkg-games/fifechan.git
 Vcs-Browser: https://anonscm.debian.org/cgit/pkg-games/fifechan.git
 
-Package: libfifechan0.1.3
+Package: libfifechan0.1.4
 Architecture: any
 Multi-Arch: same
 Depends:
@@ -37,7 +37,7 @@
 Section: libdevel
 Multi-Arch: same
 Depends:
- libfifechan0.1.3 (= ${binary:Version}),
+ libfifechan0.1.4 (= ${binary:Version}),
  ${misc:Depends}
 Description: development files for the GUI library Fifechan
  Fifechan is a lightweight cross platform GUI library written in C++

=== debian/rules ===
--- 
+++ 
@@ -1,5 +1,6 @@
 #!/usr/bin/make -f
 #export DH_VERBOSE=1
+export DEB_BUILD_MAINT_OPTIONS = hardening=+all
 
 %:
 	dh $@

## fifechan 0.1.4+git20180904

=== CMakeLists.txt ===
--- 
+++ 
@@ -23,11 +23,11 @@
 
 OPTION(BUILD_FIFECHAN_SHARED            "Build the Fifechan core library as a shared library"                ON)
 
-OPTION(ENABLE_ALLEGRO                   "Enable the Fifechan Allegro extension"                              ON)
-OPTION(BUILD_FIFECHAN_ALLEGRO_SHARED    "Build the Fifechan Allegro extension library as a shared library"   ON)
-
-OPTION(ENABLE_IRRLICHT                  "Enable the Fifechan Irrlicht extension"                             ON)
-OPTION(BUILD_FIFECHAN_IRRLICHT_SHARED   "Build the Fifechan Irrlicht extension library as a shared library"  ON)
+OPTION(ENABLE_ALLEGRO                   "Enable the Fifechan Allegro extension"                              OFF)
+OPTION(BUILD_FIFECHAN_ALLEGRO_SHARED    "Build the Fifechan Allegro extension library as a shared library"   OFF)
+
+OPTION(ENABLE_IRRLICHT                  "Enable the Fifechan Irrlicht extension"                             OFF)
+OPTION(BUILD_FIFECHAN_IRRLICHT_SHARED   "Build the Fifechan Irrlicht extension library as a shared library"  OFF)
 
 OPTION(ENABLE_OPENGL                    "Enable the Fifechan OpenGL extension"                               ON)
 OPTION(ENABLE_OPENGL_CONTRIB            "Enable the Fifechan OpenGL contrib extension (freetype, oglft)"     OFF)
@@ -81,6 +81,18 @@
 # Disable in-source builds and modifications to the source tree.
 set(CMAKE_DISABLE_SOURCE_CHANGES ON)
 set(CMAKE_DISABLE_IN_SOURCE_BUILD ON)
+
+#------------------------------------------------------------------------------
+#                                 Compiler Options                                         
+#------------------------------------------------------------------------------
+
+if(WIN32)
+  if(MSVC)
+    # ensure we use minimal "windows.h" lib without the crazy min max macros    
+    SET(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} /D \"WIN32_LEAN_AND_MEAN\"")
+    SET(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} /D \"NOMINMAX\"")
+  endif(MSVC)
+endif(WIN32)
 
 #------------------------------------------------------------------------------
 #                                 Source Files                                             
@@ -121,18 +133,22 @@
   include/fifechan/mouseevent.hpp		
   include/fifechan/mouseinput.hpp		
   include/fifechan/mouselistener.hpp	
-  include/fifechan/platform.hpp		
+  include/fifechan/platform.hpp
+  include/fifechan/point.hpp		
   include/fifechan/rectangle.hpp		
   include/fifechan/selectionevent.hpp	
-  include/fifechan/selectionlistener.hpp	
+  include/fifechan/selectionlistener.hpp
+  include/fifechan/size.hpp	
   include/fifechan/text.hpp
   include/fifechan/utf8stringeditor.hpp
+  include/fifechan/version.hpp
   include/fifechan/visibilityeventhandler.hpp
   include/fifechan/widget.hpp		
   include/fifechan/widgetlistener.hpp
   include/fifechan/opengl.hpp
 )
 FILE(GLOB FIFECHAN_WIDGET_HEADERS include/fifechan/widgets/*.hpp)
+FILE(GLOB FIFECHAN_UTIL_HEADERS include/fifechan/util/*.hpp)
 FILE(GLOB FIFECHAN_SRC src/*.cpp)
 FILE(GLOB FIFECHAN_WIDGET_SRC src/widgets/*.cpp)
 
@@ -152,10 +168,11 @@
 ENDIF(BUILD_FIFECHAN_SHARED)
 
 ADD_LIBRARY(${PROJECT_NAME} ${FIFECHAN_LIBRARY_TYPE} 
-	${FIFECHAN_HEADER} 
-	${FIFECHAN_HEADERS} 
-	${FIFECHAN_WIDGET_HEADERS} 
-	${FIFECHAN_SRC} 
+	${FIFECHAN_HEADER}
+	${FIFECHAN_HEADERS}
+	${FIFECHAN_WIDGET_HEADERS}
+	${FIFECHAN_UTIL_HEADERS}
+	${FIFECHAN_SRC}
 	${FIFECHAN_WIDGET_SRC}
 )
 
@@ -178,6 +195,7 @@
 INSTALL(FILES ${FIFECHAN_HEADER}                  DESTINATION include/)
 INSTALL(FILES ${FIFECHAN_HEADERS}                 DESTINATION include/fifechan/)
 INSTALL(FILES ${FIFECHAN_WIDGET_HEADERS}          DESTINATION include/fifechan/widgets/)
+INSTALL(FILES ${FIFECHAN_UTIL_HEADERS}            DESTINATION include/fifechan/util/)
 
 #REMOVE_DEFINITIONS("-DFIFECHAN_BUILD")
 #ADD_DEFINITIONS("-DFIFECHAN_EXTENSION_BUILD")
@@ -242,22 +260,3 @@
 
 #------------------------------------------------------------------------------
 #                   Fifechan Irrlicht extension library                                         
-#------------------------------------------------------------------------------
-
-FIND_PACKAGE(Irrlicht)
-IF(ENABLE_IRRLICHT AND IRRLICHT_FOUND)
-
-  INCLUDE_DIRECTORIES(${IRRLICHT_INCLUDE_DIR})
-
-  # The Fifechan Irrlicht extension source
-  FILE(GLOB FIFECHAN_IRRLICHT_HEADER include/fifechan/irrlicht.hpp)
-  FILE(GLOB FIFECHAN_IRRLICHT_HEADERS include/fifechan/irrlicht/*.hpp)
-  FILE(GLOB FIFECHAN_IRRLICHT_SRC src/irrlicht/*.cpp)
-
-  # Grouping of the source for nicer display in IDEs such as Visual Studio
-  SOURCE_GROUP(src/fifechan FILES ${FIFECHAN_IRRLICHT_HEADER})
-  SOURCE_GROUP(src/fifechan/irrlicht FILES ${FIFECHAN_IRRLICHT_HEADERS} ${FIFECHAN_IRRLICHT_SRC})
-
-  IF(BUILD_FIFECHAN_IRRLICHT_SHARED)
-    SET(FIFECHAN_IRRLICHT_LIBRARY_TYPE SHARED)
-  ELSE(BUILD_FIFECHAN_IRRLICHT_SHARED)

=== debian/changelog ===
fifechan (0.1.4+git20180904-1) unstable; urgency=medium

  * New upstream version 0.1.4+git20180904.
  * Switch to compat level 11.
  * Use dh_missing override.
  * Declare compliance with Debian Policy 4.2.1.
  * Remove allegro. No longer built by fifechan.

 -- Markus Koschany <apo@debian.org>  Tue, 04 Sep 2018 15:36:37 +0200

=== debian/control ===
--- 
+++ 
@@ -6,14 +6,13 @@
  Markus Koschany <apo@debian.org>
 Build-Depends:
  cmake,
- debhelper (>= 10),
- liballegro4-dev,
+ debhelper (>= 11),
  libgl1-mesa-dev,
  libglu1-mesa-dev,
  libsdl2-dev,
  libsdl2-image-dev,
  libsdl2-ttf-dev
-Standards-Version: 4.0.0
+Standards-Version: 4.2.1
 Homepage: http://fifengine.net/
 Vcs-Git: https://anonscm.debian.org/git/pkg-games/fifechan.git
 Vcs-Browser: https://anonscm.debian.org/cgit/pkg-games/fifechan.git

## fifechan 0.1.5

=== CMakeLists.txt ===
--- 
+++ 
@@ -12,7 +12,7 @@
 
 SET(MAJOR_VERSION 0)
 SET(MINOR_VERSION 1)
-SET(PATCH_VERSION 4)
+SET(PATCH_VERSION 5)
 SET(FIFECHAN_VERSION ${MAJOR_VERSION}.${MINOR_VERSION}.${PATCH_VERSION})
 
 SET(LIB_SUFFIX "" CACHE STRING "Suffix to append to the system lib folder")

=== debian/changelog ===
fifechan (0.1.5-4) unstable; urgency=medium

  * Team Upload
  * Patch for CMake 4 (Closes: #1112912)
  * Add debian/salsa-ci.yml
  * Bump Standards-Version to 4.7.2
  * Drop dpkg-dev dependency, this won't be backported

 -- Alexandre Detiste <tchet@debian.org>  Sat, 25 Oct 2025 14:55:01 +0200

fifechan (0.1.5-3.1) unstable; urgency=medium

  * Non-maintainer upload.
  * Rename libraries for 64-bit time_t transition.  Closes: #1062590

 -- Michael Hudson-Doyle <mwhudson@debian.org>  Wed, 28 Feb 2024 08:38:45 +0000

fifechan (0.1.5-3) unstable; urgency=medium

  * Declare compliance with Debian Policy 4.6.2.
  * Depend on libgl-dev instead of libgl1-mesa-dev.

 -- Markus Koschany <apo@debian.org>  Sat, 25 Feb 2023 00:04:45 +0100

fifechan (0.1.5-2) unstable; urgency=medium

  * Switch to debhelper-compat = 13.
  * Declare compliance with Debian Policy 4.5.1.
  * Remove override for dh_missing. This is now the default.

 -- Markus Koschany <apo@debian.org>  Thu, 07 Jan 2021 23:57:07 +0100

fifechan (0.1.5-1) unstable; urgency=medium

  * New upstream version 0.1.5.
  * Declare compliance with Debian Policy 4.3.0.
  * Use canonical VCS URI.
  * Rename the binary packages because of the SONAME bump.

 -- Markus Koschany <apo@debian.org>  Sun, 13 Jan 2019 21:42:28 +0100

=== debian/control ===
--- 
+++ 
@@ -6,18 +6,21 @@
  Markus Koschany <apo@debian.org>
 Build-Depends:
  cmake,
- debhelper (>= 11),
- libgl1-mesa-dev,
+ debhelper-compat (= 13),
+ libgl-dev,
  libglu1-mesa-dev,
  libsdl2-dev,
  libsdl2-image-dev,
  libsdl2-ttf-dev
-Standards-Version: 4.2.1
+Standards-Version: 4.7.2
 Homepage: http://fifengine.net/
-Vcs-Git: https://anonscm.debian.org/git/pkg-games/fifechan.git
-Vcs-Browser: https://anonscm.debian.org/cgit/pkg-games/fifechan.git
+Vcs-Git: https://salsa.debian.org/games-team/fifechan.git
+Vcs-Browser: https://salsa.debian.org/games-team/fifechan
 
-Package: libfifechan0.1.4
+Package: libfifechan0.1.5t64
+Provides: ${t64:Provides}
+Replaces: libfifechan0.1.5
+Breaks: libfifechan0.1.5 (<< ${source:Version})
 Architecture: any
 Multi-Arch: same
 Depends:
@@ -36,7 +39,7 @@
 Section: libdevel
 Multi-Arch: same
 Depends:
- libfifechan0.1.4 (= ${binary:Version}),
+ libfifechan0.1.5t64 (= ${binary:Version}),
  ${misc:Depends}
 Description: development files for the GUI library Fifechan
  Fifechan is a lightweight cross platform GUI library written in C++

=== debian/rules ===
#!/usr/bin/make -f
#export DH_VERBOSE=1
export DEB_BUILD_MAINT_OPTIONS = hardening=+all

%:
	dh $@

override_dh_auto_configure:
	dh_auto_configure -- \
		-DLIB_SUFFIX=/$(DEB_HOST_MULTIARCH)

=== debian/watch ===
version=4
opts="filenamemangle=s/(?:.*?)?v?(\d[\d.]*)\.tar\.gz/fifechan-$1.tar.gz/" \
https://github.com/fifengine/fifechan/tags (?:.*?/)?v?(\d[\d.]*)\.tar\.gz
